{$IFDEF SHISENSHO_TYPEDEF}

const
  TileSizeX=40; TileSizeY=56;  // Gre eines Tiles
  TileSetFileName='ShisenSho_Tiles.bmp';
  BackgroundFileName='ShisenSho_Background.bmp';
  FieldBorder=32;  // Gre des Spielfeldrandes
  PlayerName:string='Shisen-Sho';  // Spielername
  HintPenalty=10;  // Starfzeit bei Hinweis
  BigFontSize=54; // Gre des "Pause"/"Gewonnen"/"Verloren"-Textes
  PreferredFont='Trebuchet MS';  // ideale Schriftart dafr
  ShadowOffset=5;  // Abstand des Schattens bei diesem Text
  ForceRepaint:boolean=false;  // Neuzeichnen bei Spielfeldnderung erzwingen?
  EnlightenmentSrcColor=37;  // Paletteneintrag, den Enlightenment ndern soll
  EnlightenmentDestColor=35;  // Palleteneintrag, in den Enlightenmend ndern soll

type
  TTileCount=array[1..42]of byte;  // Liste, wieviele Tiles es pro Sprite gibt
  TPlayField=array[0..31,0..15]of byte;  // Spielfeld-Array
  TTileEntry=record X,Y,Sprite:integer;end;  // Eintrag in der History-Liste

{$ELSE}

FieldSizeX,FieldSizeY:integer;  // Gre des Spielfeldes in Steinen
FieldData:TPlayField;  // Spielfeld-Array

Field:TImage;  // Spielfeld-Control
GraphicsInitialized:boolean;  // wurden die Spielfeldgrafiken schon initialisiert?
BufSizeX,BufSizeY:integer;  // Spielfeldgre in Pixeln (mit Rand)

Back:TBitmap; BackSizeX,BackSizeY:integer;  // Hintergrund-Bitmap / Gre
Buf:TBitmap;  // Spielfeld-Puffer-Bitmap
Sprites:TBitmap;  // Sprite-Bitmap
SpriteRect:array[0..42]of TRect;  // Positionen der Sprites in der Bitmap

Paused:boolean;  // Pausenmodus-Flag

TimeSec:integer;  // Spielzeit in Sekunden
TimeBase:integer;  // GetTickCount-Wert zum Start des Spieltimers
TimeStart:integer;  // Sekunden-Startwert des Timers

ClickTileX,ClickTileY:integer;  // angeklicktes Tile
SelTileX,SelTileY:integer;  // ausgewhltes Tile

TileCount:TTileCount;  // Anzahl der Steine pro Sprite
TilePos:array[1..42,1..8]of TPoint;  // Positionen der Steine, nach Sprite-Nummer sortiert
TilesLeft:integer;  // Anzahl verbleibender Steine auf dem Spielfeld
TilesMax:integer;  // Gesamtanzahl Steine (=FieldSizeX*FieldSizeY)

MovesLeft:integer;  // Anzahl verbleibender Zge

History:array[1..200,1..2]of TTileEntry;  // Undo/Redo-Liste
HistPos:integer;  // aktuelle Position in der Liste
HistMax:integer;  // grte zulssige Positionsnummer fr Redo

HintX1,HintY1,HintX2,HintY2:integer;  // Zugvorschlag
HintAvailable:boolean;  // wurde bereits ein Zugvorschlag hervorgehoben?

procedure InitGraphics;
  // (Re-)Initialisiert Grafiken (z.B. bei Spielfeldgrennderung)
procedure Redraw;
  // Zeichnet das Spielfeld neu
procedure Flip;
  // Zeigt die Spielfeld-Bitmap an
procedure Enlightenment(TileX,TileY:integer);
  // hebt ein Tile hervor
procedure DrawBigText(const txt:string;col:TColor);
  // zeichnet einen groen, fetten Text in die Spielfeldmitte

procedure UpdateTime;
  // aktualisiert die Spielfelduhr

procedure NewGame;
  // erstellt ein neues Spiel
procedure GenerateGame_Dumb;
  // einfacher Spielfeldgenerator (nach Zufallsprinzip)
procedure GenerateGame_Clever;
  // Spielfeldgenerator, der keine unlsbaren Spiele zult
procedure CountTiles(var F:TPlayField);
  // Zhlt alle Tiles aus und fllt TileCount sowie TilePos aus

function MoveCheck(X1,Y1,X2,Y2:integer;DrawIt:boolean):boolean;
  // berprft einen Zug, auf Wunsch mit Einzeichnen des Zugpfades
function GetMoves:integer;
  // Ermittelt die Anzahl gltiger Zge sowie einen Zugvorschlag
function Solvable:boolean;
  // ermittelt, ob das Spiel (nach Ansicht des Algorithmus) lsbar ist

procedure DoMove(X1,Y1,X2,Y2:integer);
  // fhrt einen bestimmten Zug aus, mit Grafikanzeige usw.
procedure EvaluateGame;
  // wertet das Spiel aus und fllt die entsprechenden Felder im Info-Panel aus

{$ENDIF}
